<id>
Add More Membergroups - SP1
</id>

<version>
1.1
</version>

<mod info>
This allows you to add as much Membergroups as you want easily from the Admin Center.

- you can choose how many stars a Membergroup should have
  and can choose a pic for the stars (ex: staradmin.gif)
- you can add Membergroups to the category access list and if a user reaches
  the post count of the Membergroup the category will become visible
  and accessable for him
- if you give a user a Membergroup nothing else will be shown in the
  user display - except if he's an Moderator in a forum
- full implemented Global Moderator Mod (created by DaveB)
- you can set effects/colors to the MemberNames assigned to the
  Membergroups
- you can create MemberGroups which aren't accessable by posts
- you can search Members which you have given a specific MemberGroup

V 1.1:

- Fixed the bug that Global Moderators and Admins weren't checked in the Category options if they got access to a Category.
- Fixed the bug that Global Moderators and Admins still have access if the Displayed Names of the Membergroups were changed.
- Fixed some Layout Bugs (Class Tags)
- Fixed the bug that the Moderator Function picture wasn't shown

</mod info>

<author>
dOCda S!
</author>

<homepage>
http://gpu.hackers.sk/hacks/index.htm
</homepage>

<edit file>
YaBB.pl
</edit file>

<search for>
require "$sourcedir/Security.pl";
</search for>

<add after>
require "$vardir/MemberStats.txt";
</add after>

<search for>
		elsif ($action eq 'modmemgr') { require "$sourcedir/AdminEdit.pl"; &EditMemberGroups; }
		elsif ($action eq 'modmemgr2') { require "$sourcedir/AdminEdit.pl"; &EditMemberGroups2; }
</search for>

<replace>
		elsif ($action eq 'modmemgr') { require "$sourcedir/MemberGroups.pl"; &EditMemberGroups; }
		elsif ($action eq 'modmemgr2') { require "$sourcedir/MemberGroups.pl"; &EditMemberGroups2; }
</replace>

<search for>
		   if ($action eq 'modify') { require "$sourcedir/ModifyMessage.pl"; &ModifyMessage; }
</search for>

<replace>
		   if ($action eq 'moderate') { require "$sourcedir/MemberGroups.pl"; &Moderate; }
		   elsif ($action eq 'modify') { require "$sourcedir/ModifyMessage.pl"; &ModifyMessage; }
</replace>

<search for>
	elsif ($action eq 'ipban2') { require "$sourcedir/Admin.pl"; &ipban2; }
</search for>

<add after>
	elsif ($action eq 'ipbangm') { require "$sourcedir/MemberGroups.pl"; &ipban; }
	elsif ($action eq 'ipban2gm') { require "$sourcedir/MemberGroups.pl"; &ipban2; }
</add after>

<search for>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
</search for>

<add after>
	elsif ($action eq 'cefmemgr') { require "$sourcedir/MemberGroups.pl"; &MemGroup_Effects; }
	elsif ($action eq 'cefmemgr2') { require "$sourcedir/MemberGroups.pl"; &MemGroup_Effects2; }
</add after>

<search for>
	elsif ($action eq 'editnews') { require "$sourcedir/AdminEdit.pl"; &EditNews; }
</search for>

<add after>
	elsif ($action eq 'editnewsgm') { require "$sourcedir/MemberGroups.pl"; &EditNews; }
</add after>

<search for>
	elsif ($action eq 'editnews2') { require "$sourcedir/AdminEdit.pl"; &EditNews2; }
</search for>

<add after>
	elsif ($action eq 'editnews2gm') { require "$sourcedir/MemberGroups.pl"; &EditNews2; }
</add after>

<search for>
	elsif ($action eq 'admin') { require "$sourcedir/Admin.pl"; &Admin; }
</search for>

<add after>
	elsif ($action eq 'assigned') { require "$sourcedir/MemberGroups.pl"; &Assigned_Members; }
	elsif ($action eq 'assigned2') { require "$sourcedir/MemberGroups.pl"; &Assigned_Members2; }
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
~;
	fopen(FILE, "$vardir/membergroups.txt");
	@lines = <FILE>;
	fclose(FILE);
	if($settings[7] eq 'Administrator') {
		$position='';
		foreach $curl (@lines) {
			if($curl ne $lines[1] && $curl ne $lines[2] && $curl ne $lines[3] && $curl ne $lines[4] && $curl ne $lines[5] && $curl ne $lines[6]) {
				if($curl ne $lines[0]) { $position= qq~$position<option>$curl~; }
				else { $position= qq~$position<option value="Administrator">$curl~; }
			}
		}
		if($memsettings[7] eq 'Administrator') { $tt = $lines[0]; }
		else { $tt = $memsettings[7]; }
		$yymain .= qq~
      <tr>
	<td colspan=2><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'86'}: </b></font></td>
	<td><font size=2><input type=text name=settings6 size=4 value="$memsettings[6]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'87'}: </b></font></td>
	<td><font size=2><select name="settings7">
	 <option value="$memsettings[7]">$tt
	 <option value="$memsettings[7]">---------------
	 <option value="">
	 $position
	</select></font></td>
      </tr><tr>
        <td width="320"><font size=2><b>$txt{'233'}:</b><BR>
        <font size="1">$txt{'421'}</font><BR><BR></td>
        <td><input type="text" name="dr" size="20" value="$dr"><BR><BR></td>
      </tr>~;
	}
	if($settings[7] eq 'Administrator') { $confdel_text = "$txt{'775'} $txt{'777'} $INFO{'username'} $txt{'778'}"; }
	else { $confdel_text = "$txt{'775'} $txt{'776'} $txt{'778'}"; }
	$yymain .= qq~
    </table>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25" align="center"><font size=2><BR>
    <script language="JavaScript"> <!--
    function confirmDel() {if (confirm("$confdel_text")) {return true;} else {return false;}}
    // --> </script>
    <input type=submit name=moda value="$txt{'88'}">
    <input type=submit name=moda value="$txt{'89'}" onClick="return confirmDel()"><BR><BR>
    </font></td>
  </tr>
</table>
</form>
~;
	$yytitle = $txt{'79'};
	&template;
	exit;
}
</search for>

<replace>
~;
if($settings[7] eq "Administrator") {
		if($memsettings[7] eq 'Administrator') { $tt = $MemStatAdmin; }
		elsif ($memsettings[7] eq 'Global Moderator') { $tt = $MemStatGMod; }
		else { $tt = $memsettings[7]; }
	$yymain .= qq~
      <tr>
	<td colspan=2><HR size=1 width="100%" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'86'}: </b></font></td>
	<td><font size=2><input type=text name=settings6 size=4 value="$memsettings[6]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'87'}: </b></font></td>
	<td><font size=2><select name="settings7">
	 <option value="$tt">$tt
	 <option value="$memsettings[7]">---------------
	 <option value="">
~;
		$position='';
		$z=0;
	 $yymain .= qq~<option value="Administrator">$MemStatAdmin~;
	 $yymain .= qq~<option value="Global Moderator">$MemStatGMod~;
	 $yymain .= qq~<option value="$MemStatNewbie">$MemStatNewbie~;
		while($MemStat[$z]) {
			$position= qq~<option value="$MemStat[$z]">$MemStat[$z]~;
			++$z;
		$yymain .= qq~$position~;
}
		$yymain .= qq~
	</select></font></td>
      </tr><tr>
        <td width="320"><font size=2><b>$txt{'233'}:</b><BR>
        <font size=1>$txt{'421'}</font></td>
        <td><input type="text" name="dr" size="20" value="$dr"></td></tr>
~;
}
	$yymain .= qq~
    </table>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25" align="center"><font size=2><BR>
    <script language="JavaScript"> <!--
    function confirmDel() {if (confirm("$confdel_text")) {return true;} else {return false;}}
    // --> </script>
    <input type=submit name=moda value="$txt{'88'}">
    <input type=submit name=moda value="$txt{'89'}" onClick="return confirmDel()"><BR><BR>
    </font></td>
  </tr>
</table>
</form>
~;
	$yytitle = $txt{'79'};
	&template;
	exit;
}
</replace>

<search for>
	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	if($memsettings[6] > $GodPostNum) { $memberinfo = "$membergroups[6]"; }
	elsif($memsettings[6] > $SrPostNum) { $memberinfo = "$membergroups[5]"; }
	elsif($memsettings[6] > $FullPostNum) { $memberinfo = "$membergroups[4]"; }
	elsif($memsettings[6] > $JrPostNum) { $memberinfo = "$membergroups[3]"; }
	else { $memberinfo = "$membergroups[2]"; }
	if($memsettings[7] ne "") { $memberinfo = "$memsettings[7]"; }
	if($memsettings[7] eq "Administrator") { $memberinfo = "$membergroups[0]"; }
</search for>

<replace>
	my ($msstatcount);
	$msstatcount=0;
	if ($memsettings[7]) { $memberinfo = "$memsettings[7]"; } else {
	if( $memsettings[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
	while($MemStat[$msstatcount] && $MemPostNum[$msstatcount] ne "x") {
	if( $memsettings[6] >= $MemPostNum[$msstatcount] ) { $memberinfo = "$MemStat[$msstatcount]"; }
	++$msstatcount;
	}
}
</replace>

<search for>
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
</search for>

<replace>
		my($mscount);
		$mscount=0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
		$tmpa =~ s/\n//g;
			if( $settings[7] eq "$tmpa") { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if( $settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }

</replace>

<edit file>
Sources/InstantMessage.pl
</edit file>

<search for>
			$memail = $userprofile[2];
		}
		if (!$useraccount{$musername}) {$usernamelink=qq~<font size="2"><B>$musername</B></font>~; $memberinfo ="<b>$txt{'783'}</b>";}
		foreach (@censored) {
</search for>

<replace>
			$memail = $userprofile[2];
			$usernamelink = $link{$musername};
		}
		if (!$useraccount{$musername}) {$usernamelink=qq~<font size="2"><B>$musername</B></font>~; $memberinfo ="<b>$txt{'783'}</b>";}
		foreach (@censored) {
</replace>

<search for>
			$memail = $userprofile[2];
		}
		if (!$useraccount{$musername}) {$usernamelink=qq~<font size="2"><B>$musername</B></font>~; $memberinfo ="<b>$txt{'783'}</b>";}
		$message = $immessage; # put the message back in the proper variable for doing ubbc
		foreach (@censored) {
</search for>

<replace>
			$memail = $userprofile[2];
			$usernamelink = $link{$musername};
		}
		if (!$useraccount{$musername}) {$usernamelink=qq~<font size="2"><B>$musername</B></font>~; $memberinfo ="<b>$txt{'783'}</b>";}
		$message = $immessage; # put the message back in the proper variable for doing ubbc
		foreach (@censored) {
</replace>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
</search for>

<replace>
		my($mscount);
		$mscount=0;
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if($settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) { $openmemgr{$curcat} = 1; }
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
</search for>

<add after>
	if($settings[7] eq 'Global Moderator' && $allow_mod == 1) { $yymenu .= qq~$menusep<a href="$cgi;action=moderate">$img{'admin'}</a>~; }
</add after>

<search for>
		chomp $curcataccess;
		$yyAccessCat{$curcat} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
		unless( $yyAccessCat{$curcat} ) {
			foreach ( split(/\,/, $curcataccess) ) {
				if( $_ && $_ eq $settings[7] ) { $yyAccessCat{$curcat} = 1; last; }
			}
		}
</search for>

<replace>
		chomp $curcataccess;
		my($mscount);
		$mscount=0;
		$yyAccessCat{$curcat} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
		unless( $yyAccessCat{$curcat} ) {
			foreach ( split(/\,/, $curcataccess) ) {
				if( $_ && $_ eq $settings[7] ) { $yyAccessCat{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if($settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") { $memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	if ( $memberinfo eq $_ && $_ ) { $yyAccessCat{$curcat} = 1; last; }
	}
			}
		}
</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
	if($userprofile{$user}->[6] > $GodPostNum) {
		$memberinfo{$user} = "$membergroups[6]";
		$memberstar{$user} = qq~<img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*">~;
	}
	elsif($userprofile{$user}->[6] > $SrPostNum) {
		$memberinfo{$user} = "$membergroups[5]";
		$memberstar{$user} = qq~<img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*">~;
	}
	elsif($userprofile{$user}->[6] > $FullPostNum) {
		$memberinfo{$user} = "$membergroups[4]";
		$memberstar{$user} = qq~<img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*">~;
	}
	elsif($userprofile{$user}->[6] > $JrPostNum) {
		$memberinfo{$user} = "$membergroups[3]";
		$memberstar{$user} = qq~<img src="$imagesdir/star.gif" border="0" alt="*"><img src="$imagesdir/star.gif" border="0" alt="*">~;
	}
	else {
		$memberinfo{$user} = "$membergroups[2]";
		$memberstar{$user} = qq~<img src="$imagesdir/star.gif" border="0" alt="*">~;
	}
	if(exists $moderators{$user} && $sender ne "im") {
		$modinfo{$user} = "<i>$membergroups[1]</i><BR>";
		$memberstar{$user} = qq~<img src="$imagesdir/starmod.gif" border="0" alt="*"><img src="$imagesdir/starmod.gif" border="0" alt="*"><img src="$imagesdir/starmod.gif" border="0" alt="*"><img src="$imagesdir/starmod.gif" border="0" alt="*"><img src="$imagesdir/starmod.gif" border="0" alt="*">~;
	}
	if($userprofile{$user}->[7] eq 'Administrator') {
		$memberstar{$user} = qq~<img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*">~;
		$memberinfo{$user} = "<B>$membergroups[0]</B>";
	}
	if($userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Administrator') { $groupinfo{$user} = "$userprofile{$user}->[7]<BR>"; }
	if($userprofile{$user}->[7] ne 'Administrator') {
		$memberinfo{$user} = "$modinfo{$user}$groupinfo{$user}$memberinfo{$user}";
	}
</search for>

<replace>
	if( $userprofile{$user}->[7] eq 'Administrator' ) {
		if ($MemTypeAdmin == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColAdmin, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeAdmin == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColAdmin, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColAdmin><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$memberinfo{$user} = "<B>$MemStatAdmin</B>";
		$starnum = "0";
		if ($MemStarNumAdmin eq "") { $MemStarNumAdmin = "0"; }
		$memberstartemp ='';
		while($MemStarNumAdmin ne "$starnum") {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicAdmin" border="0" alt="*">);
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	} elsif ( $userprofile{$user}->[7] eq 'Global Moderator' ) {
		if ($MemTypeGMod == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColGMod, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeGMod == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColGMod, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColGMod><b>$userprofile{$user}->[1]</b></font></a><br>~; }  
		$memberinfo{$user} = "<B>$MemStatGMod</B>";
		$starnum = "0";
		if ($MemStarNumGMod eq "") { $MemStarNumGMod = "0"; }
		$memberstartemp ='';
		while($MemStarNumGMod ne "$starnum") {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicGMod" border="0" alt="*">);
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	} else {

	if ($MemStarNumNewbie eq "") { $MemStarNumNewbie = "0"; }
	$starnum = "0";
	if( $userprofile{$user}->[6] >= $MemPostNewbie) {
		if ($MemTypeNewbie == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColNewbie, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeNewbie == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColNewbie, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColNewbie><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$memberinfo{$user} = "$MemStatNewbie";
		$memberstartemp ='';
		while($MemStarNumNewbie ne "$starnum") {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicNewbie" border="0" alt="*">);
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	


	$msstatcount = "0";
	$starnum = "0";
	while($MemStat[$msstatcount]) {
	if( $userprofile{$user}->[6] >= $MemPostNum[$msstatcount] && $MemPostNum[$msstatcount] ne "x") {
		if ($MemType[$msstatcount] == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeCol[$msstatcount], direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemType[$msstatcount] == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeCol[$msstatcount], strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeCol[$msstatcount]><b>$userprofile{$user}->[1]</b></font></a><br>~; }

		$memberinfo{$user} = "$MemStat[$msstatcount]";

		if ($MemStarNum[$msstatcount] eq "") { $MemStarNum[$msstatcount] = "0"; }
		$memberstartemp ='';
		while($MemStarNum[$msstatcount] ne "$starnum") {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPic[$msstatcount]" border="0" alt="*">);
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	}
	++$msstatcount;
	}
}

	if( $userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Administrator') {
	$group{$user} = "$userprofile{$user}->[7]";
	$groupinfo{$user} = "$userprofile{$user}->[7]";
	$count=0;
	while($MemStat[$count]) {
	if ($MemStat[$count] eq "$group{$user}") {
		if ($MemType[$count] == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeCol[$count], direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemType[$count] == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeCol[$count], strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeCol[$count]><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$memberinfo{$user} = "$MemStat[$count]";

		if ($MemStarNum[$count] eq "") { $MemStarNum[$count] = "0"; }
		$memberstartemp ='';
		while($MemStarNum[$count] ne "$starnum") {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPic[$count]" border="0" alt="*">);
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	}
	$count++;
	}
}

	if( exists $moderators{$user} && $sender ne "im") {
		if ($MemTypeMod == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColMod, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeMod == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColMod, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColMod><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$modinfo{$user} = "<i>$MemStatMod</i>";
		$starnum = "0";
		if ($MemStarNumMod eq "") { $MemStarNumMod = "0"; }
		$memberstartemp ='';
		while($MemStarNumMod ne "$starnum") {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicMod" border="0" alt="*">);
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
		$starnum = "0";
	}

	if( $userprofile{$user}->[7] ne 'Administrator') {
		if ($groupinfo{$user} ne "") { $brgroup = "<BR>"; } else { $brgroup = ""; }
		if ($groupinfo{$user} eq "") {
		$memberinfo{$user} = "$memberinfo{$user}"; } else {
		$memberinfo{$user} = "$groupinfo{$user}"; }
		if ($modinfo{$user} ne "") { $memberinfo{$user} = "$modinfo{$user}$brgroup$groupinfo{$user}" }
	}
}
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator' ) {
</search for>

<replace>
	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator'  && $settings[7] ne 'Global Moderator' ) {
</replace>

<search for>
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator') {
				&fatal_error("$txt{'73'}");
			}
		}
		else {
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator') {
				&fatal_error("$txt{'67'}");
</search for>

<replace>
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) {
				&fatal_error("$txt{'73'}");
			}
		}
		else {
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
				&fatal_error("$txt{'67'}");
</replace>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator") {
</search for>

<replace>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") {
</replace>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator") { &fatal_error("$txt{'134'}"); }
</search for>

<replace>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'134'}"); }
</replace>

<search for>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator") { &fatal_error("$txt{'134'}"); }
</search for>

<replace>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'134'}"); }
</replace>

<edit file>
Sources/LockThread.pl
</edit file>

<search for>
		if((exists $moderators{$username}) || $settings[7] eq "Administrator" || ($username eq $mname && $username ne 'Guest')) {
</search for>

<replace>
		if((exists $moderators{$username}) || $settings[7] eq "Administrator" || $settings[7] ne "Global Moderator" || ($username eq $mname && $username ne 'Guest')) {
</replace>

<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_hide_email eq 1) { $yymain .= qq~
</search for>

<replace>
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
</replace>

<search for>
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_hide_email eq 1) { $yymain .= qq~
</search for>

<replace>
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
</replace>

<search for>
		if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_hide_email eq 1) { $yymain .= qq~
</search for>

<replace>
		if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
            <td class="catbg" bgcolor="$color{'catbg'}" align=right width="350"><font size=2>
            $replybutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
<table border="0" width="100%" cellpadding="0" cellspacing="0">~;
	  $yymain .= qq~
  <tr>
    <td align="left" valign="top" colspan="2">~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator') {
		$yymain .= qq~<font size="1">
	<b>$img{'admin_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a>
	<a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a>
	<a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a>
	<a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>
</font>~;
	}
</search for>

<replace>
	if($settings[7] eq 'Administrator') {
$sadminf = qq(<b>$img{'admin_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a><a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a><a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a><a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>);
}
	if(exists $moderators{$username} && $settings[7] ne 'Administrator' || $settings[7] eq 'Global Moderator') {
$sadminf = qq(<b>$img{'moderator_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a><a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a><a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a><a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>);
}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
            <td class="catbg" bgcolor="$color{'catbg'}" align=right width="350"><font size=2>
            $replybutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
<table border="0" width="100%" cellpadding="0" cellspacing="0">~;
	  $yymain .= qq~
  <tr>
    <td align="left" valign="top" colspan="2">~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
		$yymain .= qq~<font size="1">$sadminf</font>~;
	}
</replace>

<search for>
		$mip = $settings[7] eq 'Administrator' ? $mip : "$txt{'511'}";
</search for>

<replace>
		if ($settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' && $allow_mod == 1) { $mip = $mip } else { $mip = "$txt{'511'}"; }
</replace>

<search for>
			$usernamelink = qq~<font size="2"><b>$mname</b></font>~;
			$postinfo = '';
</search for>

<replace>
			$usernamelink = qq~<font size="2"><b>$mname</b></font>~;
			if ($memberinfo eq "$txt{'28'}") { $usernamelink = qq~<font size="2"><b>$mname<br></b></font>~; }
			$postinfo = '';
</replace>

<search for>
			$usernamelink = qq~<a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}"><font size="2"><b>$userprofile[1]</b></font></a>~;
</search for>

<replace>
			$usernamelink = $link{$musername};
</replace>

<search for>
            $usernamelink<BR>
</search for>

<replace>
            $usernamelink
</replace>

<search for>
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
</search for>

<replace>
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $settings[7] eq "Global Moderator" || $allow_hide_email ne 1) {
</replace>

<search for>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
</search for>

<replace>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername || $settings[7] eq 'Global Moderator') {
</replace>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=modmemgr">$txt{'8'}</a><br>
</search for>

<add after>
        - <a href="$cgi;action=cefmemgr">$amgtxt{'01'}</a><br>
        - <a href="$cgi;action=assigned">$amgtxt{'30'}</a><br>
</add after>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($gmodchecked);
</add after>

<search for>
	if ($enable_ubbc) { $ubbcchecked = ' checked'; }
</search for>

<add before>
	if ($allow_mod) { $gmodchecked = ' checked'; }
</add before>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification" $notifchecked></td>
</search for>

<add before>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'02'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allow_mod" value="1"$gmodchecked></td>
</add before>

<search for>
	$timeout = $FORM{'timeout'} || 5;
</search for>

<add before>
	$allow_mod = $FORM{'allow_mod'} || 0;
</add before>

<search for>
########## Feature Settings ##########

</search for>

<add after>
\$allow_mod = $allow_mod;  				# Set to 1 to allow Global Moderators to edit banned members list and news
</add after>

<edit file>
Sources/Security.pl
</edit file>

<search for>
sub is_admin2 {
	if($settings[7] ne 'Administrator') { &fatal_error($txt{'134'}); }
}
</search for>

<add after>
sub is_global {
	if($settings[7] ne 'Global Moderator' || $allow_mod != 1) { &fatal_error($txt{'1'}); }
}
</add after>

<edit file>
Sources/Search.pl
</edit file>

<search for>
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
</search for>

<replace>
		my($mscount);
		$mscount=0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
		$tmpa =~ s/\n//g;
			if( $settings[7] eq "$tmpa") { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if( $settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;

	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
</replace>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>
$amgtxt{'01'} = "Colors/Effects Center for Member Names";
$amgtxt{'02'} = "Allow Global Moderators to edit news and ban members?";
$amgtxt{'03'} = "Member Title to display";
$amgtxt{'04'} = "# of Posts";
$amgtxt{'05'} = "# of Stars";
$amgtxt{'06'} = "Star";
$amgtxt{'07'} = "Effect";
$amgtxt{'08'} = "Color";
$amgtxt{'09'} = "Example";
$amgtxt{'10'} = "Global Moderator Center";
$amgtxt{'11'} = "This is your Global Moderator Center. You can add/edit news items and the banned user listing.<BR><BR>If you have any problems, please read <a href=\"$helpfile\" target=\"_blank\">the manual</a> regarding these features as listed under the admin functions! You may also find answers to your problems on the";
$amgtxt{'12'} = "support forum";
$amgtxt{'13'} = "or at";
$amgtxt{'14'} = "BoardMod's Site";
$amgtxt{'15'} = "Global Moderator Options";
$amgtxt{'16'} = "Description";
$amgtxt{'17'} = "Choose Star";
$amgtxt{'18'} = "Own Pic";
$amgtxt{'19'} = "Pic";
$amgtxt{'20'} = "Administrator Star";
$amgtxt{'21'} = "Global Mod Star";
$amgtxt{'22'} = "Moderator Star";
$amgtxt{'23'} = "Blue Star";
$amgtxt{'24'} = "Silver Star";
$amgtxt{'25'} = "Gold Star";
$amgtxt{'26'} = "Other";
$amgtxt{'27'} = "Del?";
$amgtxt{'28'} = "Here you can edit/delete Member Groups!";
$amgtxt{'29'} = "Here you can add new Member Groups!";
$amgtxt{'30'} = "Search assigned Members";
$amgtxt{'31'} = "Choose MemberGroup";
$amgtxt{'32'} = "No Members found with that search criteria!";
$amgtxt{'33'} = "<b>Sorry! You made an error!</b><br><br><i><u>Error information:</u><br><br>You gave a new MemberGroup a higher or equal postcount than an already existing MemberGroup!<br>This would end in a board failure by output the user-info!<br>Please use your back button and fix this error!</i>";
$amgtxt{'34'} = "Moderator Functions:";
</add after>

<search for>
	$img{'admin_func'} = qq~<font size="1" class="imgbg">$txt{'137'}</font>~;
</search for>

<add after>
	$img{'moderator_func'} = qq~<font size="1" class="imgbg">$amgtxt{'34'}</font>~;
</add after>

<search for>
	$img{'admin_func'} = qq~<img src="$imagesdir/admin.gif" alt="$txt{'137'}" border="0"> <font size="1" class="imgbg">$txt{'137'}</font>~;
</search for>

<add after>
	$img{'moderator_func'} = qq~<img src="$imagesdir/admin.gif" alt="$txt{'137'}" border="0"> <font size="1" class="imgbg">$amgtxt{'34'}</font>~;
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
	my $mgroups = qq~<select multiple name="memgroup" size="3">~;
	fopen(FILE, "$vardir/membergroups.txt");
	@groups = <FILE>;
	fclose(FILE);
	for($i = 7; $i < @groups; ++$i ) {
		$groups[$i] =~ s/[\n\r]//g;
		chomp $groups[$i];
		$groups[$i] =~ s~\<~&lt;~g;
		$groups[$i] =~ s~\>~&gt;~g;
		$mgroups .= qq~\n<option>$groups[$i]</option>~;
</search for>

<replace>
	my $mgroups = qq~<select multiple name="memgroup" size="3">~;
		$mgroups .= qq~\n<option value="Administrator">$MemStatAdmin</option>~;
		$mgroups .= qq~\n<option value="Global Moderator">$MemStatGMod</option>~;
		$mgroups .= qq~\n<option>$MemStatNewbie</option>~;
	$count=0;
	while($MemStat[$count]) {
		$mgroups .= qq~\n<option>$MemStat[$count]</option>~;
	$count++;
</replace>

<search for>
		$mgroups = qq~<select multiple name="catgroups" size="3">~;
		for($i = 7; $i < @groups; ++$i) {
			$groups[$i] =~ s~[\n\r]~~g;
			chomp $groups[$i];
			$selected = "";
			foreach $cur (@curcatgroups) {
				$cur =~ s~[\n\r]~~g;
				chomp $cur;
				if($cur eq $groups[$i]) { $selected = " selected"; break;}
			}
			$groups[$i] =~ s~\<~&lt;~g;
			$groups[$i] =~ s~\>~&gt;~g;
			$mgroups .= qq~\n<option$selected>$groups[$i]</option>~;
</search for>

<replace>
			$adsel = "";
			$glosel = "";
			$newsel = "";
			foreach $cur (@curcatgroups) {
				$cur =~ s~[\n\r]~~g;
				chomp $cur;
				if($cur eq "Administrator") { $adsel = " selected"; break;}
				if($cur eq "Global Moderator") { $glosel = " selected"; break;}
				if($cur eq $MemStatNewbie) { $newsel = " selected"; break;}
			}
		$mgroups = qq~<select multiple name="catgroups" size="3">~;
		$mgroups .= qq~\n<option value="Administrator" $adsel>$MemStatAdmin</option>~;
		$mgroups .= qq~\n<option value="Global Moderator" $glosel>$MemStatGMod</option>~;
		$mgroups .= qq~\n<option$newsel>$MemStatNewbie</option>~;
		$count=0;

	while($MemStat[$count]) {
			$groups[$i] =~ s~[\n\r]~~g;
			chomp $groups[$i];
			$selected = "";
			foreach $cur (@curcatgroups) {
				$cur =~ s~[\n\r]~~g;
				chomp $cur;
				if($cur eq $MemStat[$count]) { $selected = " selected"; break;}
			}
			$groups[$i] =~ s~\<~&lt;~g;
			$groups[$i] =~ s~\>~&gt;~g;
			$mgroups .= qq~\n<option$selected>$MemStat[$count]</option>~;
			$count++;
</replace>