<id>
Add More MemberGroups SP1 - Update 1.0 to 1.1
</id>

<version>
1.0
</version>

<mod info>
- Fixes the bug that Global Moderators and Admins weren't checked in the Category options if they got access to a Category.
- Fixes the bug that Global Moderators and Admins still have access if the Displayed Names of the Membergroups were changed.
- Fixes some Layout Bugs (Class Tags)
- Fixes the bug that the Moderator Function picture wasn't shown

NOTE: For completing the update reupload the MemberGroups.pl within this ZIP.
</mod info>

<author>
dOCda S!
</author>

<homepage>
http://gpu.hackers.sk/hacks/index.htm
</homepage>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
	my $mgroups = qq~<select multiple name="memgroup" size="3">~;
		$mgroups .= qq~\n<option>$MemStatAdmin</option>~;
		$mgroups .= qq~\n<option>$MemStatGMod</option>~;
		$mgroups .= qq~\n<option>$MemStatNewbie</option>~;
	$count=0;
	while($MemStat[$count]) {
		$mgroups .= qq~\n<option>$MemStat[$count]</option>~;

</search for>

<replace>
	my $mgroups = qq~<select multiple name="memgroup" size="3">~;
		$mgroups .= qq~\n<option value="Administrator">$MemStatAdmin</option>~;
		$mgroups .= qq~\n<option value="Global Moderator">$MemStatGMod</option>~;
		$mgroups .= qq~\n<option>$MemStatNewbie</option>~;
	$count=0;
	while($MemStat[$count]) {
		$mgroups .= qq~\n<option>$MemStat[$count]</option>~;

</replace>

<search for>
		$mgroups = qq~<select multiple name="catgroups" size="3">~;
		$mgroups .= qq~\n<option>$MemStatAdmin</option>~;
		$mgroups .= qq~\n<option>$MemStatGMod</option>~;
		$mgroups .= qq~\n<option>$MemStatNewbie</option>~;
</search for>

<replace>
			$adsel = "";
			$glosel = "";
			$newsel = "";
			foreach $cur (@curcatgroups) {
				$cur =~ s~[\n\r]~~g;
				chomp $cur;
				if($cur eq "Administrator") { $adsel = " selected"; break;}
				if($cur eq "Global Moderator") { $glosel = " selected"; break;}
				if($cur eq $MemStatNewbie) { $newsel = " selected"; break;}
			}
		$mgroups = qq~<select multiple name="catgroups" size="3">~;
		$mgroups .= qq~\n<option value="Administrator" $adsel>$MemStatAdmin</option>~;
		$mgroups .= qq~\n<option value="Global Moderator" $glosel>$MemStatGMod</option>~;
		$mgroups .= qq~\n<option$newsel>$MemStatNewbie</option>~;
</replace>

<edit file>
english.lng
</edit file>

<search for>
	$img{'moderator_func'} = qq~<img src="$imagesdir/admin.gif.gif" alt="$txt{'137'}" border="0"> <font size="1" class="imgbg">$amgtxt{'34'}</font>~;
</search for>

<replace>
	$img{'moderator_func'} = qq~<img src="$imagesdir/admin.gif" alt="$txt{'137'}" border="0"> <font size="1" class="imgbg">$amgtxt{'34'}</font>~;
</replace>